Attribute VB_Name = "Test"
Option Explicit

Public Const conLangC = "C"
Public Const conLangVb = "Vb"

Public Const conHashIndex8 = "I8"
Public Const conHashIndex16 = "I16"

Declare Function vhash _
    Lib "vhash" _
    Alias "_vhash@8" _
    (ByVal Str As String, ByVal n As Long) As Long

Private Rand(0 To 255) As Byte
Private Str As String
Private tblSize As Long

Public Function HashVb(ByVal Str As String, ByVal n As Long) As Long
    Dim h1 As Byte
    Dim h2 As Byte
    Dim c As Byte
    Dim i As Long
    
    If n <= 256 Then
        h1 = 0
        For i = 1 To Len(Str)
            h1 = Rand(h1 Xor Asc(Mid(Str, i, 1)))
        Next i
        HashVb = h1 Mod n
    Else
        If Len(Str) = 0 Then
            HashVb = 0
            Exit Function
        End If
    
        h1 = Asc(Mid(Str, 1, 1))
        h2 = h1 + 1
        For i = 2 To Len(Str)
            c = Asc(Mid(Str, i, 1))
            h1 = Rand(h1 Xor c)
            h2 = Rand(h2 Xor c)
        Next i
    
        ' Hash is in range 0 .. 65535
        HashVb = (h1 * 256) + h2
        ' scale Hash to table size
        HashVb = HashVb Mod n
    End If
End Function
Public Sub TestC()
    Dim i As Long
    Dim v As Long
    
    For i = 1 To FMain.ItemCount
        v = vhash(Str, tblSize)
    Next i
End Sub
Public Sub TestVb()
    Dim i As Long
    Dim v As Long
    
    For i = 1 To FMain.ItemCount
        v = HashVb(Str, tblSize)
    Next i
End Sub
Public Sub Test()
    Dim StopWatch As CStopWatch
    Dim time As Single
    
    Str = String(FMain.Length, "X")
    Select Case FMain.HashIndex
    Case conHashIndex8
        tblSize = 100
    Case conHashIndex16
        tblSize = 1000
    End Select
    
    Set StopWatch = New CStopWatch
    StopWatch.Reset
    Select Case FMain.Lang
    Case conLangVb
        TestVb
    Case conLangC
        TestC
    End Select
    time = StopWatch.Elapsed / 1000!
    MsgBox "elapsed time = " & FormatNumber(time, 3) & " secs"
End Sub
Sub Init()
    Rand(0) = 41
    Rand(1) = 35
    Rand(2) = 190
    Rand(3) = 132
    Rand(4) = 225
    Rand(5) = 108
    Rand(6) = 214
    Rand(7) = 174
    Rand(8) = 82
    Rand(9) = 144
    Rand(10) = 73
    Rand(11) = 241
    Rand(12) = 187
    Rand(13) = 233
    Rand(14) = 235
    Rand(15) = 179
    Rand(16) = 166
    Rand(17) = 219
    Rand(18) = 60
    Rand(19) = 135
    Rand(20) = 12
    Rand(21) = 62
    Rand(22) = 153
    Rand(23) = 36
    Rand(24) = 94
    Rand(25) = 13
    Rand(26) = 28
    Rand(27) = 6
    Rand(28) = 183
    Rand(29) = 71
    Rand(30) = 222
    Rand(31) = 18
    Rand(32) = 77
    Rand(33) = 200
    Rand(34) = 67
    Rand(35) = 139
    Rand(36) = 31
    Rand(37) = 3
    Rand(38) = 90
    Rand(39) = 125
    Rand(40) = 9
    Rand(41) = 56
    Rand(42) = 37
    Rand(43) = 93
    Rand(44) = 212
    Rand(45) = 203
    Rand(46) = 252
    Rand(47) = 150
    Rand(48) = 245
    Rand(49) = 69
    Rand(50) = 59
    Rand(51) = 19
    Rand(52) = 137
    Rand(53) = 10
    Rand(54) = 50
    Rand(55) = 32
    Rand(56) = 154
    Rand(57) = 80
    Rand(58) = 238
    Rand(59) = 64
    Rand(60) = 120
    Rand(61) = 54
    Rand(62) = 253
    Rand(63) = 246
    Rand(64) = 158
    Rand(65) = 220
    Rand(66) = 173
    Rand(67) = 79
    Rand(68) = 20
    Rand(69) = 242
    Rand(70) = 68
    Rand(71) = 102
    Rand(72) = 208
    Rand(73) = 107
    Rand(74) = 196
    Rand(75) = 48
    Rand(76) = 161
    Rand(77) = 34
    Rand(78) = 145
    Rand(79) = 157
    Rand(80) = 218
    Rand(81) = 176
    Rand(82) = 202
    Rand(83) = 2
    Rand(84) = 185
    Rand(85) = 114
    Rand(86) = 44
    Rand(87) = 128
    Rand(88) = 126
    Rand(89) = 197
    Rand(90) = 213
    Rand(91) = 178
    Rand(92) = 234
    Rand(93) = 201
    Rand(94) = 204
    Rand(95) = 83
    Rand(96) = 191
    Rand(97) = 103
    Rand(98) = 45
    Rand(99) = 142
    Rand(100) = 131
    Rand(101) = 239
    Rand(102) = 87
    Rand(103) = 97
    Rand(104) = 255
    Rand(105) = 105
    Rand(106) = 143
    Rand(107) = 205
    Rand(108) = 209
    Rand(109) = 30
    Rand(110) = 156
    Rand(111) = 22
    Rand(112) = 230
    Rand(113) = 29
    Rand(114) = 240
    Rand(115) = 74
    Rand(116) = 119
    Rand(117) = 215
    Rand(118) = 232
    Rand(119) = 57
    Rand(120) = 51
    Rand(121) = 116
    Rand(122) = 244
    Rand(123) = 159
    Rand(124) = 164
    Rand(125) = 89
    Rand(126) = 53
    Rand(127) = 207
    Rand(128) = 211
    Rand(129) = 72
    Rand(130) = 117
    Rand(131) = 217
    Rand(132) = 42
    Rand(133) = 229
    Rand(134) = 192
    Rand(135) = 247
    Rand(136) = 43
    Rand(137) = 129
    Rand(138) = 14
    Rand(139) = 95
    Rand(140) = 0
    Rand(141) = 141
    Rand(142) = 123
    Rand(143) = 5
    Rand(144) = 21
    Rand(145) = 7
    Rand(146) = 130
    Rand(147) = 24
    Rand(148) = 112
    Rand(149) = 146
    Rand(150) = 100
    Rand(151) = 84
    Rand(152) = 206
    Rand(153) = 177
    Rand(154) = 133
    Rand(155) = 248
    Rand(156) = 70
    Rand(157) = 106
    Rand(158) = 4
    Rand(159) = 115
    Rand(160) = 47
    Rand(161) = 104
    Rand(162) = 118
    Rand(163) = 250
    Rand(164) = 17
    Rand(165) = 136
    Rand(166) = 121
    Rand(167) = 254
    Rand(168) = 216
    Rand(169) = 40
    Rand(170) = 11
    Rand(171) = 96
    Rand(172) = 61
    Rand(173) = 151
    Rand(174) = 39
    Rand(175) = 138
    Rand(176) = 194
    Rand(177) = 8
    Rand(178) = 165
    Rand(179) = 193
    Rand(180) = 140
    Rand(181) = 169
    Rand(182) = 149
    Rand(183) = 155
    Rand(184) = 168
    Rand(185) = 167
    Rand(186) = 134
    Rand(187) = 181
    Rand(188) = 231
    Rand(189) = 85
    Rand(190) = 78
    Rand(191) = 113
    Rand(192) = 226
    Rand(193) = 180
    Rand(194) = 101
    Rand(195) = 122
    Rand(196) = 99
    Rand(197) = 38
    Rand(198) = 223
    Rand(199) = 109
    Rand(200) = 98
    Rand(201) = 224
    Rand(202) = 52
    Rand(203) = 63
    Rand(204) = 227
    Rand(205) = 65
    Rand(206) = 15
    Rand(207) = 27
    Rand(208) = 243
    Rand(209) = 160
    Rand(210) = 127
    Rand(211) = 170
    Rand(212) = 91
    Rand(213) = 184
    Rand(214) = 58
    Rand(215) = 16
    Rand(216) = 76
    Rand(217) = 236
    Rand(218) = 49
    Rand(219) = 66
    Rand(220) = 124
    Rand(221) = 228
    Rand(222) = 33
    Rand(223) = 147
    Rand(224) = 175
    Rand(225) = 111
    Rand(226) = 1
    Rand(227) = 23
    Rand(228) = 86
    Rand(229) = 198
    Rand(230) = 249
    Rand(231) = 55
    Rand(232) = 189
    Rand(233) = 110
    Rand(234) = 92
    Rand(235) = 195
    Rand(236) = 163
    Rand(237) = 152
    Rand(238) = 199
    Rand(239) = 182
    Rand(240) = 81
    Rand(241) = 25
    Rand(242) = 46
    Rand(243) = 188
    Rand(244) = 148
    Rand(245) = 75
    Rand(246) = 88
    Rand(247) = 210
    Rand(248) = 172
    Rand(249) = 26
    Rand(250) = 162
    Rand(251) = 237
    Rand(252) = 251
    Rand(253) = 221
    Rand(254) = 186
    Rand(255) = 171
End Sub
